
#' Realization of a simulated multivariate time series
#' 
#' @name Y
#' @title Simulated Multivariate Time Series
#' @docType data
#' @details \eqn{100 \times 3} multivariate time series distributed according to the generator matrix \link{A}.
#' @author Will Nicholson
NULL

#' Coefficient matrix for a stationary simulated multivariate time series
#' 
#' @name A
#' @title Generator for Simulated Multivariate Time Series
#' @docType data
#' @details Example generator matrix adapted from Table 3.2 of Gredenhoff and Karlsson (1997)
#' @references Gredenhoff, Mikael, and Sune Karlsson. "Lag-length selection in VAR-models using equal and unequal lag-length procedures." Computational Statistics 14.2 (1999): 171-187.
#' @author Will Nicholson
 NULL
